#include "stack.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void initStack(Stack *s) {
    s->top = -1;
}

bool isEmpty(Stack *s) {
    return s->top == -1;
}

bool isFull(Stack *s) {
    return s->top == MAX_STACK_SIZE - 1;
}

bool push(Stack *s, const char *value, char type) {
    if (isFull(s)) {
        fprintf(stderr, "Stack overflow!\n");
        return false;
    }
    char *new_str = malloc(strlen(value) + 1);
    if (new_str == NULL) {
        fprintf(stderr, "Memory allocation failed!\n");
        return false;
    }
    strcpy(new_str, value);
    s->top++;
    s->data[s->top].str_ptr = new_str;
    s->data[s->top].type = type;
    return true;
}

bool pop(Stack *s, Element *out) {
    if (isEmpty(s)) {
        fprintf(stderr, "Stack is empty!\n");
        return false;
    }
    *out = s->data[s->top--];
    return true;
}

bool peek(Stack *s, Element *out) {
    if (isEmpty(s)) {
        fprintf(stderr, "Stack is empty!\n");
        return false;
    }
    *out = s->data[s->top];
    return true;
}

void clearStack(Stack *s) {
    while (s->top >= 0) {
        free(s->data[s->top].str_ptr);
        s->top--;
    }
}